create or replace package PKG_P8PANELS_EQUIPSRV as

  /*      */
  procedure GET_DEFAULT_FP
  (
    COUT                    out clob    -- XML     
  );
  
  /*    -  */
  function HOURS_STR
  (
    NHOURS                  in number   -- - 
  ) return                  varchar2;   --  
  
  /*   (   )   */
  procedure SELECT_EQUIPSRV
  (
    SBELONG                 in varchar2,         --   . 
    SPRODOBJ                in varchar2,         --  
    STECHSERV               in varchar2 := null, --  
    SRESPDEP                in varchar2 := null, --  
    STECHNAME               in varchar2,         --   
    SSRVKIND                in varchar2,         --   
    NYEAR                   in number,           -- 
    NMONTH                  in number,           -- 
    NDAY                    in number := null,   -- 
    NWORKTYPE               in number,           --   (0 - , 1 - )
    NIDENT                  out number           --    (  , null -  )
  );
  
  /*     */
  procedure EQUIPSRV_GRID
  (
    SBELONG                 in varchar2,         --   . 
    SPRODOBJ                in varchar2,         --  
    STECHSERV               in varchar2 := null, --  
    SRESPDEP                in varchar2 := null, --  
    NFROMMONTH              in number,           --   
    NFROMYEAR               in number,           --   
    NTOMONTH                in number,           --   
    NTOYEAR                 in number,           --   
    COUT                    out clob             --  
  );
  
end PKG_P8PANELS_EQUIPSRV;
/
create or replace package body PKG_P8PANELS_EQUIPSRV as
  
  /*      */
  procedure GET_DEFAULT_FP
  (
    COUT                    out clob                               -- XML     
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- .  
    SJUR_PERS               PKG_STD.TSTRING := null;               -- .  ()
    NJUR_PERS               PKG_STD.TREF := null;                  -- .  ()
  begin
    /*  .  */
    FIND_JURPERSONS_MAIN(NFLAG_SMART => 1, NCOMPANY => NCOMPANY, SJUR_PERS => SJUR_PERS, NJUR_PERS => NJUR_PERS);
    /*  XML */
    PKG_XFAST.PROLOGUE(ITYPE => PKG_XFAST.CONTENT_);
    PKG_XFAST.DOWN_NODE(SNAME => 'DATA');
    PKG_XFAST.DOWN_NODE(SNAME => 'JURPERS');
    PKG_XFAST.VALUE(SVALUE => SJUR_PERS);
    PKG_XFAST.UP();
    PKG_XFAST.DOWN_NODE(SNAME => 'MONTH');
    PKG_XFAST.VALUE(NVALUE => EXTRACT(month from sysdate));
    PKG_XFAST.UP();
    PKG_XFAST.DOWN_NODE(SNAME => 'YEAR');
    PKG_XFAST.VALUE(NVALUE => EXTRACT(year from sysdate));
    PKG_XFAST.UP();
    PKG_XFAST.UP();
    /*   clob */
    COUT := PKG_XFAST.SERIALIZE_TO_CLOB();
    PKG_XFAST.EPILOGUE();
  end GET_DEFAULT_FP;
  
  /*    -  */
  function HOURS_STR
  (
    NHOURS                  in number        -- - 
  ) return                  varchar2         --   - 
  is
    SRESULT                 PKG_STD.TSTRING; --  
  begin
    if ((mod(NHOURS, 10) = 1) and (mod(NHOURS, 100) != 11)) then
      SRESULT := NHOURS || ' ';
    elsif (((mod(NHOURS, 10) = 2) and (mod(NHOURS, 100) != 12)) or ((mod(NHOURS, 10) = 3) and (mod(NHOURS, 100) != 13)) or
          ((mod(NHOURS, 10) = 4) and (mod(NHOURS, 100) != 14))) then
      SRESULT := NHOURS || ' ';
    else
      SRESULT := NHOURS || ' ';
    end if;
    return SRESULT;
  end HOURS_STR;
  
  /*   (   )   */
  procedure SELECT_EQUIPSRV
  (
    SBELONG                 in varchar2,                           --   . 
    SPRODOBJ                in varchar2,                           --  
    STECHSERV               in varchar2 := null,                   --  
    SRESPDEP                in varchar2 := null,                   --  
    STECHNAME               in varchar2,                           --   
    SSRVKIND                in varchar2,                           --   
    NYEAR                   in number,                             -- 
    NMONTH                  in number,                             -- 
    NDAY                    in number := null,                     -- 
    NWORKTYPE               in number,                             --   (0 - , 1 - )
    NIDENT                  out number                             --    (  , null -  )
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- .  
    NSELECTLIST             PKG_STD.TREF;                          -- .     
    SDATE                   PKG_STD.TSTRING;                       --                     
  begin
    /*      */
    if (NDAY is not null) then
      SDATE := LPAD(TO_CHAR(NDAY), 2, '0') || '.' || LPAD(TO_CHAR(NMONTH), 2, '0') || '.' || NYEAR;
    else
      SDATE := LPAD(TO_CHAR(NMONTH), 2, '0') || '.' || NYEAR;
    end if;
    /*    */
    if (NWORKTYPE = 0) then
      for C in (select T.RN,
                       T.COMPANY
                  from EQTCHSRV       T,
                       JURPERSONS     J,
                       EQTECSRVKIND   SK,
                       EQCONFIG       C1,
                       EQCONFIG       C2,
                       INS_DEPARTMENT DS,
                       INS_DEPARTMENT DR
                 where T.STATE in (1, 2)
                   and T.COMPANY = NCOMPANY
                   and T.JUR_PERS = J.RN
                   and J.CODE = SBELONG
                   and T.EQCONFIG = C1.RN
                   and C1.CODE = SPRODOBJ
                   and T.DEPTTCSRV = DS.RN
                   and (DS.CODE = STECHSERV or STECHSERV is null)
                   and T.DEPTRESP = DR.RN
                   and (DR.CODE = SRESPDEP or SRESPDEP is null)
                   and T.EQCONFIG_TECH = C2.RN
                   and C2.NAME = STECHNAME
                   and T.EQTECSRVKIND = SK.RN
                   and SK.CODE = SSRVKIND
                   and ((NDAY is not null and TO_DATE(SDATE, 'dd.mm.yyyy') between TRUNC(T.DATEPRD_BEG) and
                       TRUNC(T.DATEPRD_END)) or (NDAY is null and (SDATE = TO_CHAR(T.DATEPRD_BEG, 'mm.yyyy') or
                       SDATE = TO_CHAR(T.DATEPRD_END, 'mm.yyyy')))))
      loop
        /*    */
        if (NIDENT is null) then
          NIDENT := GEN_IDENT();
        end if;
        /*       */
        P_SELECTLIST_BASE_INSERT(NIDENT       => NIDENT,
                                 NCOMPANY     => C.COMPANY,
                                 NDOCUMENT    => C.RN,
                                 SUNITCODE    => 'EquipTechServices',
                                 SACTIONCODE  => null,
                                 NCRN         => null,
                                 NDOCUMENT1   => null,
                                 SUNITCODE1   => null,
                                 SACTIONCODE1 => null,
                                 NRN          => NSELECTLIST);
      end loop;
      /*    */
    else
      for C in (select T.RN,
                       T.COMPANY
                  from EQRPSHEETS   T,
                       JURPERSONS   J,
                       EQTECSRVKIND SK,
                       EQCONFIG     C
                 where T.STATE in (0, 2, 3)
                   and T.COMPANY = NCOMPANY
                   and T.JURPERSONS = J.RN
                   and J.CODE = SBELONG
                   and T.EQCONFIG = C.RN
                   and C.NAME = STECHNAME
                   and T.TECSRVKIND = SK.RN
                   and SK.CODE = SSRVKIND
                   and ((NDAY is not null and TO_DATE(SDATE, 'dd.mm.yyyy') between TRUNC(T.DATEFACT_BEG) and
                       TRUNC(T.DATEFACT_END)) or (NDAY is null and (SDATE = TO_CHAR(T.DATEFACT_BEG, 'mm.yyyy') or
                       SDATE = TO_CHAR(T.DATEFACT_END, 'mm.yyyy')))))
      loop
        /*    */
        if (NIDENT is null) then
          NIDENT := GEN_IDENT();
        end if;
        /*       */
        P_SELECTLIST_BASE_INSERT(NIDENT       => NIDENT,
                                 NCOMPANY     => C.COMPANY,
                                 NDOCUMENT    => C.RN,
                                 SUNITCODE    => 'EquipRepairSheets',
                                 SACTIONCODE  => null,
                                 NCRN         => null,
                                 NDOCUMENT1   => null,
                                 SUNITCODE1   => null,
                                 SACTIONCODE1 => null,
                                 NRN          => NSELECTLIST);
      end loop;
    end if;
  end SELECT_EQUIPSRV;

  /*     */
  procedure EQUIPSRV_GRID
  (
    SBELONG                 in varchar2,                           --   . 
    SPRODOBJ                in varchar2,                           --  
    STECHSERV               in varchar2 := null,                   --  
    SRESPDEP                in varchar2 := null,                   --  
    NFROMMONTH              in number,                             --   
    NFROMYEAR               in number,                             --   
    NTOMONTH                in number,                             --   
    NTOYEAR                 in number,                             --   
    COUT                    out clob                               --  
  )
  is
    NCOMPANY                PKG_STD.TREF := GET_SESSION_COMPANY(); -- .  
    SPRJ_GROUP_NAME         PKG_STD.TSTRING;                       --    
    BEXPANDED               boolean;                               --   
    RDG                     PKG_P8PANELS_VISUAL.TDATA_GRID;        --  
    RDG_ROW0                PKG_P8PANELS_VISUAL.TROW;              --  0
    RDG_ROW                 PKG_P8PANELS_VISUAL.TROW;              --  
    RDG_ROW2                PKG_P8PANELS_VISUAL.TROW;              --  2
    NCURYEAR                PKG_STD.TNUMBER;                       --  
    NCURMONTH               PKG_STD.TNUMBER;                       --  
    NTOTALDAYS              PKG_STD.TNUMBER;                       --    
    SCURTECHOBJ             PKG_STD.TSTRING := null;               --   
    SCURTSKCODE             PKG_STD.TSTRING := null;               --   
    NFROMDATE               PKG_STD.TLDATE;                        --   
    NTODATE                 PKG_STD.TLDATE;                        --   
    NMS                     PKG_STD.TNUMBER;                       --     
    NME                     PKG_STD.TNUMBER;                       --     
    NYEAR_PLAN              PKG_STD.TNUMBER;                       --  
    NMONTH_PLAN             PKG_STD.TNUMBER;                       --  
    NDAY_PLAN               PKG_STD.TNUMBER;                       --  
    NYEAR_FACT              PKG_STD.TNUMBER;                       --  
    NMONTH_FACT             PKG_STD.TNUMBER;                       --  
    NDAY_FACT               PKG_STD.TNUMBER;                       --  
    SPERIODNAME             PKG_STD.TSTRING;                       --  
    SFACT_CLR               PKG_STD.TSTRING;                       --    
    NROWS                   PKG_STD.TNUMBER := 0;                  -- -      
    NWORKPERDAY             PKG_STD.TNUMBER(17,2) := null;         --    
    SGROUP_FILLED           PKG_STD.TLSTRING;                      -- ,   /
    SCOLS                   PKG_STD.TLSTRING;                      --       
    YM                      PKG_CONTVALLOC1S.TCONTAINER;           --      
    MCLR                    PKG_CONTVALLOC1S.TCONTAINER;           --    
    CR                      PKG_STD.TSTRING;                       --    MCLR
    
    /*     */
    cursor C1 is
           select TT.NEQV_RN,
                  TT.NEQS_RN,
                  TT.NWRK_RN NRN,
                  TT.COMPANY NCOMPANY,
                  TT.NAME_WORK SWORKNAME,
                  EC2.CODE STECHOBJCODE,
                  EC2.NAME STECHOBJNAME,
                  JP.CODE SBELONG,
                  EC1.CODE SPRODOBJ,
                  DS.CODE STECHSERV,
                  DR.CODE SRESPDEP,
                  TT.DATEPRD_BEG DDATEPLANBEG,
                  TT.DATEPRD_END DDATEPLANEND,
                  EQJ.DATEFACT_BEG DDATEFACTBEG,
                  EQJ.DATEFACT_END DDATEFACTEND,
                  EK.CODE STECSRVKINDCODE,
                  EK.NAME STECSRVKINDNAME,
                  COALESCE(EW.NSUM, (TT.DATEPRD_END - TT.DATEPRD_BEG) * 24) NSUMWORKPLAN,
                  COALESCE(EWJ.NSUMF, (EQJ.DATEFACT_END - EQJ.DATEFACT_BEG) * 24) NSUMWORKFACT
             from (select B.*,
                          C.RN           NWRK_RN,
                          C.PRN          NWRK_PRN,
                          C.NAME_WORK,
                          C.DATEPLAN_BEG,
                          C.DATEPLAN_END,
                          C.TECSRVKIND,
                          C.EQCONFIG,
                          C.DEPTPERF,
                          C.DEPTTCSRV,
                          C.RESP_AGN
                     from (select EQV.RN          NEQV_RN,
                                  EQV.COMPANY,
                                  EQV.JUR_PERS,
                                  EQV.STATE,
                                  EQV.DATEPRD_BEG,
                                  EQV.DATEPRD_END,
                                  EQS.RN          NEQS_RN
                             from EQTCHSRV   EQV,
                                  DOCLINKS   DL,
                                  EQRPSHEETS EQS
                            where EQV.RN = DL.IN_DOCUMENT(+)
                              and DL.OUT_UNITCODE(+) = 'EquipRepairSheets'
                              and DL.OUT_DOCUMENT = EQS.RN(+)) B,
                          EQTCHSRWRK C
                    where B.NEQV_RN = C.PRN(+)
                   union all
                   select B.*,
                          C.RN           NWRK_RN,
                          C.PRN          NWRK_PRN,
                          C.NAME_WORK,
                          C.DATEPLAN_BEG,
                          C.DATEPLAN_END,
                          C.TECSRVKIND,
                          C.EQCONFIG,
                          C.DEPTPERF,
                          null           DEPTTCSRV,
                          C.RESP_AGN
                     from (select null             NEQV_RN,
                                  EQS.COMPANY,
                                  EQS.JURPERSONS   JUR_PERS,
                                  EQS.STATE,
                                  EQS.DATEPLAN_BEG,
                                  EQS.DATEPLAN_END,
                                  EQS.RN           NEQS_RN
                             from EQRPSHEETS EQS
                            where not exists (select 1
                                     from DOCLINKS DL
                                    where DL.OUT_DOCUMENT = EQS.RN
                                      and DL.IN_UNITCODE = 'EquipTechServices')) B,
                          EQRPSHWRK C
                    where B.NEQS_RN = C.PRN(+)) TT,
                  EQTECSRVKIND EK,
                  JURPERSONS JP,
                  EQCONFIG EC1,
                  EQCONFIG EC2,
                  INS_DEPARTMENT DS,
                  INS_DEPARTMENT DR,
                  DOCLINKS DL,
                  EQTECSRVJRNL EQJ,
                  (select T.PRN,
                          sum(T.WORKTIMEPLAN * T.PERFORM_QUANT) NSUM
                     from EQTCHSRWRC T
                    group by T.PRN) EW,
                  (select T.PRN,
                          sum(T.WORKTIMEFACT * T.QUANTFACT) NSUMF
                     from EQTCHSRJRNLWRC T
                    group by T.PRN) EWJ
            where TT.COMPANY = NCOMPANY
              and ((TT.STATE in (1, 2) and NEQV_RN is not null) or (TT.STATE in (0, 2, 3) and NEQV_RN is null))
              and TT.DATEPRD_BEG >= NFROMDATE
              and TT.DATEPRD_END <= NTODATE
              and JP.CODE = SBELONG
              and EC1.CODE = SPRODOBJ
              and (DS.CODE = STECHSERV or STECHSERV is null)
              and (DR.CODE = SRESPDEP or SRESPDEP is null)
              and TT.EQCONFIG = EC2.RN(+)
              and TT.DEPTPERF = DR.RN(+)
              and TT.DEPTTCSRV = DS.RN(+)
              and TT.NWRK_RN = EW.PRN(+)
              and EQJ.RN = EWJ.PRN(+)
              and TT.TECSRVKIND = EK.RN(+)
              and TT.NWRK_RN = DL.IN_DOCUMENT(+)
              and ((DL.OUT_UNITCODE = 'EquipTechServiceJournal' and DL.RN is not null) or
                  (DL.OUT_UNITCODE is null and DL.RN is null))
              and DL.OUT_DOCUMENT = EQJ.RN(+)
            order by EC2.NAME,
                     EK.CODE;
  begin
    /*     */
    NFROMDATE := TO_DATE('01.' || LPAD(TO_CHAR(NFROMMONTH), 2, '0') || '.' || TO_CHAR(NFROMYEAR), 'dd.mm.yyyy');
    /*     */
    NTODATE := LAST_DAY(TO_DATE('01.' || LPAD(TO_CHAR(NTOMONTH), 2, '0') || '.' || TO_CHAR(NTOYEAR), 'dd.mm.yyyy'));
    /*    */
    RDG := PKG_P8PANELS_VISUAL.TDATA_GRID_MAKE();
    /*    */
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'STEST',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SINFO',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SINFO2',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               SPARENT    => 'SINFO');
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'NRN',
                                               SCAPTION   => '. ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_NUMB,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SWORKNAME',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'STECHOBJCODE',
                                               SCAPTION   => ' . ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'STECHOBJNAME',
                                               SCAPTION   => ' . ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SBELONG',
                                               SCAPTION   => '',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SPRODOBJ',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'STECHSERV',
                                               SCAPTION   => '. ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'SRESPDEP',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'STECSERVCODE',
                                               SCAPTION   => ' ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'DDATEPLANBEG',
                                               SCAPTION   => '  ()',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_DATE,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'DDATEPLANEND',
                                               SCAPTION   => '  ()',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_DATE,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'DDATEFACTBEG',
                                               SCAPTION   => '  ()',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_DATE,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'DDATEFACTEND',
                                               SCAPTION   => '  ()',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_DATE,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'STECSRVKINDCODE',
                                               SCAPTION   => '  ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                               SNAME      => 'STECSRVKINDNAME',
                                               SCAPTION   => '  ',
                                               SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                               BVISIBLE   => false);
    /*   */
    PKG_CONTVALLOC1S.PURGE(RCONTAINER => YM);
    PKG_CONTVALLOC1S.PURGE(RCONTAINER => MCLR);
    /*   */
    NCURYEAR := EXTRACT(year from sysdate);
    /*   */
    NCURMONTH := EXTRACT(month from sysdate);
    /*     */
    for Y in NFROMYEAR .. NTOYEAR
    loop
      if (NFROMYEAR = NTOYEAR) then
        NMS := NFROMMONTH;
        NME := NTOMONTH;
      else
        if (Y = NFROMYEAR) then
          NMS := NFROMMONTH;
          NME := 12;
        elsif ((NFROMYEAR < Y) and (Y < NTOYEAR)) then
          NMS := 1;
          NME := 12;
        elsif (Y = NTOYEAR) then
          NMS := 1;
          NME := NTOMONTH;
        end if;
      end if;
      /*     */
      for M in NMS .. NME
      loop
        PKG_CONTVALLOC1S.PUTN(RCONTAINER => YM, SROWID => '_' || TO_CHAR(Y) || '_' || TO_CHAR(M) || '_P', NVALUE => 0);
        PKG_CONTVALLOC1S.PUTN(RCONTAINER => YM, SROWID => '_' || TO_CHAR(Y) || '_' || TO_CHAR(M) || '_F', NVALUE => 0);
        /*          */
        if ((Y = NCURYEAR) and (M = NCURMONTH)) then
          BEXPANDED := true;
        else
          BEXPANDED := false;
        end if;
        PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID  => RDG,
                                                   SNAME       => '_' || TO_CHAR(Y) || '_' || TO_CHAR(M),
                                                   SCAPTION    => LPAD(TO_CHAR(M), 2, '0') || ' ' || TO_CHAR(Y),
                                                   SDATA_TYPE  => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                                   BEXPANDABLE => true,
                                                   BEXPANDED   => BEXPANDED);
        /*  -    */
        NTOTALDAYS := TO_NUMBER(TO_CHAR(LAST_DAY(TO_DATE('01.' || LPAD(TO_CHAR(M), 2, '0') || '.' || TO_CHAR(Y),
                                                         'dd.mm.yyyy')),
                                        'dd'),
                                '99');
        /*     */
        for D in 1 .. NTOTALDAYS
        loop
          PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_COL_DEF(RDATA_GRID => RDG,
                                                     SNAME      => '_' || TO_CHAR(Y) || '_' || TO_CHAR(M) || '_' ||
                                                                   TO_CHAR(D),
                                                     SCAPTION   => TO_CHAR(D, '99'),
                                                     SDATA_TYPE => PKG_P8PANELS_VISUAL.SDATA_TYPE_STR,
                                                     SPARENT    => '_' || TO_CHAR(Y) || '_' || TO_CHAR(M));
        end loop;
      end loop;
    end loop;
    /*  -    */
    for Q1 in C1
    loop
      NROWS := NROWS + 1;
    end loop;
    /*    */
    for QQ in C1
    loop
      NROWS := NROWS - 1;
      /*     */
      if ((SCURTECHOBJ != QQ.STECHOBJNAME) or (SCURTECHOBJ is null)) then
        /*         */
        if (RDG_ROW0.RCOLS is not null) then
          /*     */
          for Y in NFROMYEAR .. NTOYEAR
          loop
            /*      */
            if (NFROMYEAR = NTOYEAR) then
              NMS := NFROMMONTH;
              NME := NTOMONTH;
              /*   -      */
            else
              if (Y = NFROMYEAR) then
                NMS := NFROMMONTH;
                NME := 12;
              elsif ((NFROMYEAR < Y) and (Y < NTOYEAR)) then
                NMS := 1;
                NME := 12;
              elsif (Y = NTOYEAR) then
                NMS := 1;
                NME := NTOMONTH;
              end if;
            end if;
            /*    ,       */
            for M in NMS .. NME
            loop
              SPERIODNAME := '_' || TO_CHAR(Y) || '_' || TO_CHAR(M);
              PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW   => RDG_ROW0,
                                               SNAME  => SPERIODNAME,
                                               SVALUE => ': ' ||
                                                         HOURS_STR(PKG_CONTVALLOC1S.GETN(YM, SPERIODNAME || '_P')) ||
                                                         ' : ' ||
                                                         HOURS_STR(PKG_CONTVALLOC1S.GETN(YM, SPERIODNAME || '_F')));
              /*      */
              PKG_CONTVALLOC1S.PUTN(RCONTAINER => YM, SROWID => SPERIODNAME || '_P', NVALUE => 0);
              /*      */
              PKG_CONTVALLOC1S.PUTN(RCONTAINER => YM, SROWID => SPERIODNAME || '_F', NVALUE => 0);
            end loop;
          end loop;
          /*     */
          PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_ROW(RDATA_GRID => RDG, RROW => RDG_ROW0);
        end if;
        /*      */
        SCURTECHOBJ     := QQ.STECHOBJNAME;
        SPRJ_GROUP_NAME := SCURTECHOBJ;
        PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_GROUP(RDATA_GRID  => RDG,
                                                 SNAME       => SPRJ_GROUP_NAME,
                                                 SCAPTION    => QQ.STECHOBJNAME,
                                                 BEXPANDABLE => false);
        RDG_ROW0 := PKG_P8PANELS_VISUAL.TROW_MAKE(SGROUP => SPRJ_GROUP_NAME);
        PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW0, SNAME => 'STEST', SVALUE => SCURTECHOBJ);
      end if;
      /*       */
      SCURTSKCODE := SCURTECHOBJ || '_' || QQ.STECSRVKINDCODE;
      /*           */
      if (STRIN(SSUBSTR => SCURTSKCODE, SSOURCE => SGROUP_FILLED, SDELIM => ';') = 0) then
        /*    */
        if (RDG_ROW.RCOLS is not null) then
          PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_ROW(RDATA_GRID => RDG, RROW => RDG_ROW);
        end if;
        /*    */
        if (RDG_ROW2.RCOLS is not null) then
          CR := PKG_CONTVALLOC1S.FIRST_(RCONTAINER => MCLR);
          /*       */
          for Z in 1 .. PKG_CONTVALLOC1S.COUNT_(RCONTAINER => MCLR)
          loop
            PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW   => RDG_ROW2,
                                             SNAME  => CR,
                                             SVALUE => PKG_CONTVALLOC1S.GETS(RCONTAINER => MCLR, SROWID => CR));
            CR := PKG_CONTVALLOC1S.NEXT_(RCONTAINER => MCLR, SROWID => CR);
          end loop;
          PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_ROW(RDATA_GRID => RDG, RROW => RDG_ROW2);
        end if;
        PKG_CONTVALLOC1S.PURGE(RCONTAINER => MCLR);
        /*      */
        SPRJ_GROUP_NAME := SCURTSKCODE;
        PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_GROUP(RDATA_GRID  => RDG,
                                                 SNAME       => SPRJ_GROUP_NAME,
                                                 SCAPTION    => QQ.STECSRVKINDCODE,
                                                 BEXPANDABLE => false);
        /*   */
        RDG_ROW := PKG_P8PANELS_VISUAL.TROW_MAKE(SGROUP => SPRJ_GROUP_NAME);
        PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'STEST', SVALUE => QQ.STECSRVKINDCODE);
        PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => 'SINFO2', SVALUE => '');
        /*   */
        RDG_ROW2 := PKG_P8PANELS_VISUAL.TROW_MAKE(SGROUP => SPRJ_GROUP_NAME);
        PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW2, SNAME => 'SINFO2', SVALUE => '');
        /*     */
        SGROUP_FILLED := SGROUP_FILLED || SPRJ_GROUP_NAME || ';';
      end if;
      /*   */
      if (QQ.NEQV_RN is not null) then
        /*    */
        for X in 0 .. TRUNC(QQ.DDATEPLANEND) - TRUNC(QQ.DDATEPLANBEG)
        loop
          NYEAR_PLAN  := EXTRACT(year from QQ.DDATEPLANBEG + X);
          NMONTH_PLAN := EXTRACT(month from QQ.DDATEPLANBEG + X);
          NDAY_PLAN   := EXTRACT(day from QQ.DDATEPLANBEG + X);
          /*     */
          if (X = 0) then
            SPERIODNAME := '_' || TO_CHAR(NYEAR_PLAN) || '_' || NMONTH_PLAN;
            /*     */
            if (QQ.NSUMWORKPLAN is not null) then
              PKG_CONTVALLOC1S.PUTN(RCONTAINER => YM,
                                    SROWID     => SPERIODNAME || '_P',
                                    NVALUE     => PKG_CONTVALLOC1S.GETN(RCONTAINER => YM, SROWID => SPERIODNAME || '_P') +
                                                  QQ.NSUMWORKPLAN);
            end if;
            /*     */
            if (STRIN(SSUBSTR => SPRJ_GROUP_NAME || ' ' || SPERIODNAME || ' PLAN', SSOURCE => SCOLS, SDELIM => ';') = 0) then
              PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => SPERIODNAME, SVALUE => 'blue');
              SCOLS := SCOLS || SPRJ_GROUP_NAME || ' ' || SPERIODNAME || ' PLAN;';
            end if;
          end if;
          SPERIODNAME := '_' || TO_CHAR(NYEAR_PLAN) || '_' || TO_CHAR(NMONTH_PLAN) || '_' || TO_CHAR(NDAY_PLAN);
          /*     */
          if (STRIN(SSUBSTR => SPRJ_GROUP_NAME || ' ' || SPERIODNAME || ' PLAN', SSOURCE => SCOLS, SDELIM => ';') = 0) then
            PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW => RDG_ROW, SNAME => SPERIODNAME, SVALUE => 'blue');
            SCOLS := SCOLS || SPRJ_GROUP_NAME || ' ' || SPERIODNAME || ' PLAN;';
          end if;
        end loop;
      end if;
      /*     */
      if ((QQ.DDATEFACTEND is not null) and (QQ.DDATEFACTBEG is not null)) then
        /*  - ,  -  */
        if (QQ.NEQV_RN is not null) then
          SFACT_CLR := 'green';
        else
          SFACT_CLR := 'red';
        end if;
        NWORKPERDAY := null;
        /*      ,      */
        if (EXTRACT(month from QQ.DDATEFACTBEG) != EXTRACT(month from QQ.DDATEFACTEND)) then
          NWORKPERDAY := QQ.NSUMWORKFACT / (ROUND(QQ.DDATEFACTEND - QQ.DDATEFACTBEG) + 1);
          NCURMONTH   := EXTRACT(month from QQ.DDATEFACTBEG);
        end if;
        /*    */
        for X in 0 .. TRUNC(QQ.DDATEFACTEND) - TRUNC(QQ.DDATEFACTBEG)
        loop
          NYEAR_FACT  := EXTRACT(year from QQ.DDATEFACTBEG + X);
          NMONTH_FACT := EXTRACT(month from QQ.DDATEFACTBEG + X);
          NDAY_FACT   := EXTRACT(day from QQ.DDATEFACTBEG + X);
          /*         */
          if ((X = 0) or (NCURMONTH != NMONTH_FACT)) then
            /*    */
            if (NCURMONTH != NMONTH_FACT) then
              NCURMONTH := NMONTH_FACT;
            end if;
            SPERIODNAME := '_' || TO_CHAR(NYEAR_FACT) || '_' || NMONTH_FACT;
            /*          */
            if ((QQ.NSUMWORKFACT is not null) and (NWORKPERDAY is null)) then
              PKG_CONTVALLOC1S.PUTN(RCONTAINER => YM,
                                    SROWID     => SPERIODNAME || '_F',
                                    NVALUE     => PKG_CONTVALLOC1S.GETN(RCONTAINER => YM, SROWID => SPERIODNAME || '_F') +
                                                  QQ.NSUMWORKFACT);
            end if;
            /*      */
            if (PKG_CONTVALLOC1S.EXISTS_(RCONTAINER => MCLR, SROWID => SPERIODNAME) = false) then
              PKG_CONTVALLOC1S.PUTS(RCONTAINER => MCLR, SROWID => SPERIODNAME, SVALUE => SFACT_CLR);
            else
              /*      */
              if (STRIN(trim(SFACT_CLR), trim(PKG_CONTVALLOC1S.GETS(MCLR, SPERIODNAME))) = 0) then
                PKG_CONTVALLOC1S.PUTS(RCONTAINER => MCLR,
                                      SROWID     => SPERIODNAME,
                                      SVALUE     => PKG_CONTVALLOC1S.GETS(RCONTAINER => MCLR, SROWID => SPERIODNAME) || ' ' ||
                                                    SFACT_CLR);
              end if;
            end if;
          end if;
          /*           */
          if (NWORKPERDAY is not null) then
            PKG_CONTVALLOC1S.PUTN(RCONTAINER => YM,
                                  SROWID     => SPERIODNAME || '_F',
                                  NVALUE     => PKG_CONTVALLOC1S.GETN(RCONTAINER => YM, SROWID => SPERIODNAME || '_F') +
                                                NWORKPERDAY);
          end if;
          SPERIODNAME := '_' || TO_CHAR(NYEAR_FACT) || '_' || TO_CHAR(NMONTH_FACT) || '_' || TO_CHAR(NDAY_FACT);
          /*       */
          if (PKG_CONTVALLOC1S.EXISTS_(RCONTAINER => MCLR, SROWID => SPERIODNAME) = false) then
            PKG_CONTVALLOC1S.PUTS(RCONTAINER => MCLR, SROWID => SPERIODNAME, SVALUE => SFACT_CLR);
          else
            /*      */
            if ((trim(PKG_CONTVALLOC1S.GETS(RCONTAINER => MCLR, SROWID => SPERIODNAME)) = 'green') and
               (trim(SFACT_CLR) = 'red')) then
              PKG_CONTVALLOC1S.PUTS(RCONTAINER => MCLR, SROWID => SPERIODNAME, SVALUE => SFACT_CLR);
            end if;
          end if;
        end loop;
      end if;
      if ((RDG_ROW0.RCOLS is not null) and (NROWS = 0)) then
        /*     */
        for Y in NFROMYEAR .. NTOYEAR
        loop
          if (NFROMYEAR = NTOYEAR) then
            NMS := NFROMMONTH;
            NME := NTOMONTH;
          else
            if (Y = NFROMYEAR) then
              NMS := NFROMMONTH;
              NME := 12;
            elsif ((NFROMYEAR < Y) and (Y < NTOYEAR)) then
              NMS := 1;
              NME := 12;
            elsif (Y = NTOYEAR) then
              NMS := 1;
              NME := NTOMONTH;
            end if;
          end if;
          /*     */
          for M in NMS .. NME
          loop
            SPERIODNAME := '_' || TO_CHAR(Y) || '_' || TO_CHAR(M);
            PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW   => RDG_ROW0,
                                             SNAME  => SPERIODNAME,
                                             SVALUE => ': ' ||
                                                       HOURS_STR(NHOURS => PKG_CONTVALLOC1S.GETN(RCONTAINER => YM,
                                                                                                 SROWID     => SPERIODNAME || '_P')) ||
                                                       ' : ' ||
                                                       HOURS_STR(NHOURS => PKG_CONTVALLOC1S.GETN(RCONTAINER => YM,
                                                                                                 SROWID     => SPERIODNAME || '_F')));
          end loop;
        end loop;
        PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_ROW(RDATA_GRID => RDG, RROW => RDG_ROW0);
      end if;
      /*     */
      if ((RDG_ROW.RCOLS is not null) and (NROWS = 0)) then
        PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_ROW(RDATA_GRID => RDG, RROW => RDG_ROW);
      end if;
      /*     */
      if ((RDG_ROW2.RCOLS is not null) and (NROWS = 0)) then
        CR := PKG_CONTVALLOC1S.FIRST_(RCONTAINER => MCLR);
        for Z in 1 .. PKG_CONTVALLOC1S.COUNT_(RCONTAINER => MCLR)
        loop
          PKG_P8PANELS_VISUAL.TROW_ADD_COL(RROW   => RDG_ROW2,
                                           SNAME  => CR,
                                           SVALUE => PKG_CONTVALLOC1S.GETS(RCONTAINER => MCLR, SROWID => CR));
          CR := PKG_CONTVALLOC1S.NEXT_(RCONTAINER => MCLR, SROWID => CR);
        end loop;
        PKG_P8PANELS_VISUAL.TDATA_GRID_ADD_ROW(RDATA_GRID => RDG, RROW => RDG_ROW2);
      end if;
    end loop;
    /*   */
    COUT := PKG_P8PANELS_VISUAL.TDATA_GRID_TO_XML(RDATA_GRID => RDG, NINCLUDE_DEF => 1);
    PKG_CONTVALLOC1S.PURGE(RCONTAINER => YM);
  end EQUIPSRV_GRID;
 
end PKG_P8PANELS_EQUIPSRV;
/
